/*
    NOTE: When EMBEDDED_WBACRAES_TABLES defined, sometimes compiler heap limit reached. 
    Use /Zm option for increase heap limit size. (example: /Zm300) 
*/

#ifndef WAESCIPHER_TRANS_H
#define WAESCIPHER_TRANS_H

#include "WAESCipher.h"

// WHEN DEFINED, WBACRAES_xxx FUNCTION USES PRE-GENERATED TABLES STORED IN 'xxx\AESxxx.h' HEADERS (PATHS SET IN WAESCipher_Trans.cpp)
// ELSE, CWAESCipher PARENT METHOD IS CALLED 
#define EMBEDDED_TABLES_WAESCIPHER_TRANS_TABLES

class CWAESCipher_Trans : public CWAESCipher {
public: 
    // WBACR_AES CIPHERING    
    int WBACRAES_EncryptOneBlock(BYTE plainBlock[BLOCK_LENGTH], BYTE encryptedBlock[BLOCK_LENGTH], int nRounds); 
    int WBACRAES_DecryptOneBlock(BYTE encryptedBlock[BLOCK_LENGTH], BYTE plainBlock[BLOCK_LENGTH], int nRounds); 
};


#endif